﻿local addonName, QD = ...; -- gets addon-local variables

----------------------------------------------------------------------------------------------------
-- public variables
QuiDicit = {}; -- public variables and functions

----------------------------------------------------------------------------------------------------
-- local constants
QD.PRIORITY_COLOR_INDIVIDUAL = 1; -- individual colors have priority
QD.PRIORITY_COLOR_GROUP = 2; -- group colors have priority

QD.DEFAULT_COLOR = "FFFFFF";
QD.TEXTON = "|cFF00ce00[ON]|r";
QD.TEXTOFF = "|cFFce0000[OFF]|r";

QD.actionID = {
    GROUPCREATE = 0,
    GROUPCOLOR = 1,
    GROUPCLEAR = 2,
    GROUPDELETE = 3,
    CHARCOLOR = 4,
    CHARGROUP = 5,
    CHARUNCOLOR = 6,
    CHARUNGROUP = 7,
    CHARDELETE = 8,
    OPTIONS = 9,
    TOGGLEONOFF = 10,
    TOGGLECOLORNAMES = 11,
    TOGGLECOLORLINES = 12,
    SHOWCOLORS = 13,
};


----------------------------------------------------------------------------------------------------
-- local variables
-- QD.SavedVariables = nil; -- variable for saving at logout

QD.on = true; -- addon is active
-- QD.autoGuild = true; -- recognizes guilds when possible
-- QD.nearby = false; -- TODO special group for nearby people
QD.colorNames = true;
QD.colorLines = false;
--QD.colorChatBubbles = false;

QD.priority = QD.PRIORITY_COLOR_INDIVIDUAL; -- 1 for single, 2 for group

QD.preText = ""; -- text before the character name
QD.postText = ""; -- text after the character name

QD.LOCALIZATION = {};

-- PopupMenu
-- UnitPopupButtons["QUIDICIT"] = { text = "QuiDicit", dist = 0 };

QD.colors = { -- color codes
    chatcommand = "|cFF9e9e9e",
}

QD.usedChannels = { -- channel with interest coloring, ChatTypeInfo
    ["SAY"]          = true, -- RP
    ["YELL"]         = true, -- RP
    ["EMOTE"]        = true, -- RP
    ["PARTY"]        = false, -- Group
    ["RAID"]         = false, -- Raid
    ["BATTLEGROUND"] = false, -- PvP
    ["GUILD"]        = false, -- guild
}

-- hash tables for user colors
QD.vips = {}; -- very interesting persons
QD.vigs = {}; -- very intersting groups
-- QD.noi = {}; -- nothing of interest


----------------------------------------------------------------------------------------------------
-- local base functions

function QD.printInfo(text)
    DEFAULT_CHAT_FRAME:AddMessage( text, 0.5, 0.5, 0.5);
end

function QD.printDebug(text)
    DEFAULT_CHAT_FRAME:AddMessage( "QD:   " .. text, 1.0, 0.0, 0.0 );
end

function QuiDicit.RGBToHex(r, g, b)
	r = r <= 255 and r >= 0 and r or 0
	g = g <= 255 and g >= 0 and g or 0
	b = b <= 255 and b >= 0 and b or 0
	return string.format("%02x%02x%02x", r, g, b)
end

function QuiDicit.RGBPercToHex(r, g, b)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end

function QuiDicit.HexToRGB(hex)
	local rhex, ghex, bhex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6)
	return tonumber(rhex, 16), tonumber(ghex, 16), tonumber(bhex, 16)
end

function QuiDicit.HexToRGBPerc(hex)
	local rhex, ghex, bhex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6)
	return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
end

-- function QuiDicit.getTableLength(T)
  -- local count = 0
  -- for _ in pairs(T) do count = count + 1 end
  -- return count
-- end